=== debian/changelog ===
ecl (24.5.10.20250914.git294da20+dfsg-3) sid; urgency=medium

  * Fix m68k typo
  * Added some documentation to the patches

 -- Peter Van Eynde <pvaneynd@debian.org>  Wed, 08 Oct 2025 07:56:49 +0200

ecl (24.5.10.20250914.git294da20+dfsg-2) sid; urgency=medium

  * On the suggestion of the ecl maintainers, see if disabling threading fixes
    some ports
  * Make lintian override work on other architectures

 -- Peter Van Eynde <pvaneynd@debian.org>  Tue, 07 Oct 2025 18:24:49 +0200

ecl (24.5.10.20250914.git294da20+dfsg-1) unstable; urgency=medium

  * Updated Standards-Version, no changes
  * Added man pages
  * Apply https://salsa.debian.org/common-lisp-team/ecl/-/merge_requests/2
    manually
  * Moved to proper dfsg suffix
  * Temporary track the GIT state to test the new version with gcc-15 support
    (Closes: 1096562)
  * New upstream version 24.5.10.20250914.git294da20+dfsg
  * Revert t64 changes. (Closes: #1092000)
  * Add libraries to package. (Closes: 1008176)
  * Added temporary patch to show the right Git commit
  * Fixed copyright files

 -- Peter Van Eynde <pvaneynd@debian.org>  Fri, 26 Sep 2025 11:26:07 +0200
