=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=24.5.10.%cd.git%h, dversionmangle=s/\+(dfsg|ds)\d*$//, repacksuffix=+dfsg" \
https://gitlab.com/embeddable-common-lisp/ecl.git \
HEAD debian uupdate
